# this is an example modular config file that uses server names as context
use IO::Pipe;

our %remoteserveraction;

#foreach $context ("s1") { $s{$context}->{hostname}=$context; }

# after a file is done, we can call extra post scripts
push(@filedonehooks, sub{
	my($context, $infilename, $basefilename, $outfilename)=@_;
				my $postscriptfilename="in/$basefilename.post";
				if(-e $postscriptfilename) {
					eval getFileContent $postscriptfilename;
				}
	});

# prefilterhooks check .post mtime
push(@prefilterhooks, sub{
      my($context, $infilename, $basefilename, $outfilename, $needpost)=@_;
      if(getmtime($outfilename)<getmtime("in/$basefilename.post")) { $_[4]=1 }
   });

# permissions on out dir are managed by contextdonehook:
push(@contextdonehooks, sub{
		my($context, $didwrite)=@_;
		return unless $didwrite;
      return unless $options{copy};
#print "rsync -a out/$context/ root\@$context:/\n"; # would need fakeroot for root owned files
      my $remoteaction=join(" ; ", "cd / ; tar x", keys(%remoteserveraction)); %remoteserveraction=();
# this might cause some problems with quoting special chars
# if you need files not owned by root, we could use fakeroot
#		my $cmd="cd out/$context/ ; tar --owner=0 --group=0 -c ./ | ssh root\@$context '$remoteaction'";
      diag($remoteaction);
#      system($cmd);
### replaces system($cmd)
      if(1){ # 
         my $pipe=new IO::Pipe;
         $SIG{CHLD}="IGNORE";
         my $pid=fork();
         if(!defined($pid)) { die "fork failed"}
         if($pid==0) {   # child
            $pipe->writer();
            open(STDOUT, ">&", fileno($pipe));
            exec("/bin/tar", "--directory=$options{out}/$context", qw"--owner=0 --group=0 -c ./");
            die "exec tar failed: $!";
         }
         $pipe->reader();
         $pid=fork();
         if(!defined($pid)) { die "fork failed"}
         if($pid==0) {   # child
            open(STDIN, "<&=", fileno($pipe));
            alarm($options{sshtimeout});
            exec("/usr/bin/ssh", "root\@$context", $remoteaction);
            die "exec ssh $context failed: $!";
         }
         waitpid($pid, 0);
      }
### end of block

	});
